package com.developpez.rpouiller.partagelibrairiesversionnees.classloaders;

import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.catalina.loader.WebappClassLoader;
import org.apache.catalina.startup.Bootstrap;

import sun.net.spi.nameservice.dns.DNSNameService;

public class Servlet extends HttpServlet {

    private static final ClassLoader CLASSLOADER_SYSTEM = ClassLoader.getSystemClassLoader();
    private static final ClassLoader CLASSLOADER_DNS_NAME_SERVICE = DNSNameService.class.getClassLoader();
    private static final ClassLoader CLASSLOADER_BOOTSTRAP = Bootstrap.class.getClassLoader();
    private static final ClassLoader CLASSLOADER_WEBAPP_CLASS_LOADER = WebappClassLoader.class.getClassLoader();
    private static final ClassLoader CLASSLOADER_SERVLET = Servlet.class.getClassLoader();
    
    @Override
    protected void doGet(HttpServletRequest pRequete, HttpServletResponse pReponse) throws ServletException, IOException {
        
        final StringBuffer lStringBuffer= new StringBuffer();
        
        lStringBuffer.append("<HTML><TITLE>ClassLoaders</TITLE>\n");
        lStringBuffer.append("<BODY>\n");
        lStringBuffer.append("<FONT FACE=\"Courier New\">\n");

        ClassLoader lClassLoader = Thread.currentThread().getContextClassLoader();
        while(lClassLoader != null) {
            lStringBuffer.append(lClassLoader.getClass().getCanonicalName() + " : ");
            if(CLASSLOADER_SYSTEM == lClassLoader)              lStringBuffer.append("[ClassLoader Systme]");
            if(CLASSLOADER_DNS_NAME_SERVICE == lClassLoader)    lStringBuffer.append("[ClassLoader DNSNameService]");
            if(CLASSLOADER_BOOTSTRAP == lClassLoader)           lStringBuffer.append("[ClassLoader Bootstrap]");
            if(CLASSLOADER_WEBAPP_CLASS_LOADER == lClassLoader) lStringBuffer.append("[ClassLoader WebappClassLoader]");
            if(CLASSLOADER_SERVLET == lClassLoader)             lStringBuffer.append("[ClassLoader Servlet]");
            if(lClassLoader instanceof URLClassLoader)          lStringBuffer.append("[URLClassLoader]");
            lStringBuffer.append("<BR/>\n");
            if(lClassLoader instanceof URLClassLoader) {
                final URLClassLoader lURLClassLoader = (URLClassLoader)lClassLoader;
                final URL[] lURLs = lURLClassLoader.getURLs();
                for(int i=0;i<lURLs.length;i++) {
                    lStringBuffer.append("&nbsp;&nbsp;&nbsp;&nbsp;" + lURLs[i] + "<BR/>\n");
                }
            }
            lClassLoader = lClassLoader.getParent();
        }

        lStringBuffer.append("</FONT>\n");
        lStringBuffer.append("</BODY></HTML>");

        pReponse.getWriter().print(lStringBuffer.toString());
    }

}